/*
 *  include/linux/power/rt5025/rt5025-charger.h
 *  Include header file for Richtek RT5025 Core charger Driver
 *
 *  Copyright (C) 2014 Richtek Technology Corp.
 *  cy_huang <cy_huang@richtek.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 */

#ifndef __LINUX_RT5025_CHARGER_H
#define __LINUX_RT5025_CHARGER_H

enum {
	CHGEVENT_TIMEOUT_CC,
	CHGEVENT_TIMEOUT_PC,
	CHGEVENT_CHVSREGI = 5,
	CHGEVENT_CHTREGI,
	CHGEVENT_CHRCHGI,
	CHGEVENT_CHTERMI,
	CHGEVENT_CHBATOVI,
	CHGEVENT_CHGOODI_INUSB,
	CHGEVENT_CHBADI_INUSB,
	CHGEVENT_CHSLPI_INUSB,
	CHGEVENT_CHGOODI_INAC,
	CHGEVENT_CHBADI_INAC,
	CHGEVENT_CHSLPI_INAC,
	CHGEVENT_BATABS,
	CHGEVENT_INUSB_PLUGIN = 19,
	CHGEVENT_INUSBOVP,
	CHGEVENT_INAC_PLUGIN = 22,
	CHGEVENT_INACOVP,
	/*append TALRT IRQ*/
	CHGEVENT_TALRTMIN = 28,
	CHGEVENT_TALRTMAX = 29,
	CHGEVENT_MAX,
};

enum {
	RT5025_BATTEMP_COLD,
	RT5025_BATTEMP_COOL,
	RT5025_BATTEMP_NORMAL,
	RT5025_BATTEMP_WARM,
	RT5025_BATTEMP_HOT,
	RT5025_BATTEMP_MAX,
};

enum {
	RT5025_INTTEMP_NORMAL,
	RT5025_INTTEMP_WARM,
	RT5025_INTTEMP_HOT,
	RT5025_INTTEMP_MAX,
};

#define RT5025_CHGIPREC_MASK	0x01
#define RT5025_CHGIPREC_SHFT	0
#define RT5025_CHGIEOC_MASK	0x02
#define RT5025_CHGIEOC_SHFT	1
#define RT5025_CHGVPREC_MASK	0x1C
#define RT5025_CHGVPREC_SHFT	2
#define RT5025_CHGVDPM_MASK	0x30
#define RT5025_CHGVDPM_SHFT	4

#define RT5025_CHGCEN_MASK	0x10
#define RT5025_CHGAICR_MASK	0x06
#define RT5025_CHGAICR_SHFT	1
#define RT5025_CHGICC_MASK	0x78
#define RT5025_CHGICC_SHFT	3
#define RT5025_CHGCV_MASK	0xFC
#define RT5025_CHGCV_SHFT	2
#define RT5025_CHGTEEN_MASK	0x04
#define RT5025_BATDEN_MASK	0x40
#define RT5025_VBUSHZ_MASK	0x01
#define RT5025_CHGBCEN_MASK	0x02
#define RT5025_CHRCHGI_MASK	0x80
#define RT5025_CHTERMI_MASK	0x01
#define RT5025_ACUSABLE_MASK	0x02
#define RT5025_USBUSABLE_MASK	0x01

#define RT5025_TALRTMX_MASK	0x20
#define RT5025_TALRTMN_MASK	0x10

#endif /* #ifndef __LINUX_RT5025_POWER_H */
